#include<stdio.h>
#include"ConfigLib.h"

void main(int argc, char** argv[])

{
  t_gmurfrc* my_gmurfrc;
  t_dsprc*   my_dsprc;

  char filename[80];

  if (argc != 2)
    {
      strcpy(filename,"coucou.gmurfrc");
      printf("Creating new %s file...",filename);
      my_gmurfrc = gmurfrc_defaults();
      gmurfrc_write(my_gmurfrc, "coucou.gmurfrc");
      gmurfrc_destroy(my_gmurfrc);
      printf("Done.\n");
    } /* if */

  else 
    
    { 
      strcpy(filename,argv[1]);
    } /* else */

  printf("Reading conf file from %s...\n",filename);
  my_gmurfrc = gmurfrc_read(filename);
  if (my_gmurfrc == NULL)
    {
      printf("Erreur: ce fichier n'est pas de type Gmurfrc!\n");
      exit(-1);
    }

  printf("Fields for t_gmurfrc are:\n");
  printf("t_gmurfrc->num_of_dsps: %d\n",my_gmurfrc->num_of_dsps);
  printf("t_gmurfrc->buffer_size: %d\n",my_gmurfrc->buffer_size);
  printf("t_gmurfrc->tempdir    : %s\n",my_gmurfrc->temp_dir);

  my_dsprc = my_gmurfrc->first_dsp;

  while (my_dsprc != NULL)
    {
      printf("\nFields for t_gmurfrc->next_dsp are:\n");
      printf("first_dsp->vendor         : %s\n",my_dsprc->vendor);
      printf("first_dsp->bits_per_sample: %d\n",my_dsprc->bits_per_sample);
      printf("first_dsp->channels       : %d\n",my_dsprc->channels);
      printf("first_dsp->sample_rate    : %d\n",my_dsprc->sample_rate);
      printf("first_dsp->name           : %s\n",my_dsprc->name);
      my_dsprc = my_dsprc->next_dsp;
    }

  gmurfrc_destroy(my_gmurfrc);

} /* main */
