/*
** Filter_Data.c
**
** Procedures to use the filter plugins datas.
** sam-lo_p@epita.fr
*/

#include"Filter_Data.h"

t_filterdata	*filterdata_new(path)
char		*path;
{
  int		fd;
  t_filter_data	*filter_data;
  t_filterdata  *filterdata;

  filter_data = (t_filter_data *) malloc(sizeof(t_filter_data));
  filterdata  = (t_filterdata*) malloc(sizeof(t_filterdata));
  
  if ((fd = open(path, O_RDWR)) == -1)
    {
      warning("Filter_Data.c: filterdata: Can't open filterdata file");
      free(filter_data);
      free(filterdata);
      return (NULL);
    }
  if (read(fd, filter_data, sizeof(t_filter_data)) <= 0)
    {
      warning("Filter_Data.c: filterdata: Can't read filterdata file");
      free(filter_data);
      free(filterdata);
      return (NULL);
    }

  filterdata->fd = fd;
  filterdata->filter_data = filter_data;

  return (filterdata);
}

int filterdata_write(filterdata)
     t_filterdata* filterdata;
{
  lseek(filterdata->fd, 0, SEEK_SET);
  if (write(filterdata->fd, filterdata->filter_data, sizeof(t_filter_data)) == -1)
    {
      warning("Filter_Data.c: filterdata_write: Can't write filterdata");
      return (-1);
    }
  return(0);
}

int filterdata_destroy(filterdata)
     t_filterdata* filterdata;
{
  filterdata_write(filterdata);

  close(filterdata->fd);
  free(filterdata->filter_data);
  free(filterdata);
  return(0);
}
